#ifndef _LIBCODICT_H
#define _LIBCODICT_H 1

#ifdef __cplusplus
extern "C" {
#endif

typedef struct libcodict_dict dict_t;
typedef struct libcodict_passwd passwd_t;

struct libcodict_dict {
	dict_t *next;
	char *usr;		// user string
	passwd_t *pwds;		// links to beginning of passwd_t
};

struct libcodict_passwd {
	passwd_t *next;		// links to users next password
	char *str;		// password string
};

extern dict_t *dict_init(void);
extern dict_t *dict_read(FILE *, dict_t *);
extern dict_t *dict_ccreate(dict_t *, char *);
extern dict_t *dict_create(char *);
extern void dict_output(FILE *, dict_t *);
extern passwd_t *dict_add_pwd(dict_t *, char *, passwd_t *);
extern int dict_del_pwd(dict_t *, passwd_t *);
extern dict_t *dict_add_usr(dict_t *, char *);
extern int dict_del_usr(dict_t *, dict_t *);
extern void dict_destroy(dict_t *);
extern dict_t *dict_clone(dict_t *);
extern dict_t *dict_merge(dict_t *, dict_t *);

#ifdef __cplusplus
}
#endif

#endif /* !_LIBDICT_H */
